﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
//using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;


using System.IO;
using System.Diagnostics;
using System.Windows.Forms.Design;
using Microsoft.Xna.Framework;
using Microsoft.Xna.Framework.Graphics;

using System.Runtime.InteropServices;

namespace code
{




	public partial class MainForm : Form
	{
		[DllImport("User32.dll")]
        public static extern short GetAsyncKeyState(int vKey);
        
	    static public GraphicsDevice                   m_device         = null;
		Timer                                   m_timer;
    
    
		
		Vector3									m_supportNormal	 = new Vector3(0,1,0);
		Vector3									m_random		 = new Vector3(0,0,0);
		Model_c[]								m_model			 = new Model_c[2];
		
		
		
		System.Drawing.Point    m_lastMousePos	= new System.Drawing.Point(0,0);
		Vector3                 m_camRot      	= new Vector3(0,0,0);
		Vector3                 m_lastCamRot  	= new Vector3(0,0,0);
		float                   m_camDist     	= -100.0f;
		float                   m_lastCamDist 	= -100.0f;
    
		public MainForm()
		{
			InitializeComponent();
		}
		
		
		
		void UpdateCamera()
		{
			Matrix camRot = Matrix.CreateRotationY(m_camRot.Y) * Matrix.CreateRotationX(m_camRot.X);
	        
			float aspectRatio = (float)m_device.Viewport.Width / m_device.Viewport.Height;
			Camera_c.s_view = Matrix.CreateLookAt( Vector3.Transform(new Vector3(0,0,m_camDist), camRot),
												  Vector3.Zero,
												  Vector3.Up);      
	    
			Camera_c.s_projection = Matrix.CreatePerspectiveFieldOfView(MathHelper.ToRadians(45.0f), 
																 aspectRatio, 
																 1.0f, 
																 1000.0f);
	                                               
	        
			System.Drawing.Point mp = System.Windows.Forms.Cursor.Position;
	        
			System.Drawing.Point clientMP = pictureBox.PointToClient( mp );
			bool mouseInWindow = false;
			if (clientMP.X>0 && clientMP.X<pictureBox.Width &&
				clientMP.Y>0 && clientMP.Y<pictureBox.Height)
			{
				mouseInWindow = true;
			}

			if (mouseInWindow && System.Windows.Forms.Control.MouseButtons == MouseButtons.Left)
			{
			   float mouseSpeed = 0.01f;
			   float dx = (mp.X - m_lastMousePos.X)*mouseSpeed;
			   m_camRot.Y = m_lastCamRot.Y + dx;
	           
			   float dy = (mp.Y - m_lastMousePos.Y)*mouseSpeed;
			   m_camRot.X = m_lastCamRot.X + dy;
			}
			else if (mouseInWindow && System.Windows.Forms.Control.MouseButtons == MouseButtons.Right)
			{
				float zoomSpeed = 0.5f;
				float dy = (mp.Y - m_lastMousePos.Y)*zoomSpeed;
				m_camDist = m_lastCamDist - dy;
			}
			else
			{
				m_lastCamDist  = m_camDist;
				m_lastCamRot   = m_camRot;
				m_lastMousePos = mp;
			}
		}
    
		protected override void OnLoad(EventArgs e)
		{
			base.OnLoad(e);

			PresentationParameters pp = new PresentationParameters();
			pp.BackBufferCount          = 1;
			pp.IsFullScreen             = false;
			pp.SwapEffect               = SwapEffect.Discard;
			pp.BackBufferWidth          = pictureBox.Width;
			pp.BackBufferHeight         = pictureBox.Height;
			pp.AutoDepthStencilFormat   = DepthFormat.Depth24Stencil8;
			pp.EnableAutoDepthStencil   = true;
			pp.PresentationInterval     = PresentInterval.Default;
			pp.BackBufferFormat         = SurfaceFormat.Unknown;
			pp.MultiSampleType          = MultiSampleType.None;

			m_device = new GraphicsDevice(  GraphicsAdapter.DefaultAdapter,
											DeviceType.Hardware, 
											this.pictureBox.Handle,
											pp);

			m_device.PresentationParameters.BackBufferWidth   = pictureBox.Width;
			m_device.PresentationParameters.BackBufferHeight  = pictureBox.Height;
			m_device.Reset();

			m_device.RenderState.AlphaBlendEnable	= true;
			m_device.RenderState.DestinationBlend	= Blend.InverseSourceAlpha;
			m_device.RenderState.SourceBlend		= Blend.SourceAlpha;


			//float aspectRatio = (float)m_device.Viewport.Width / m_device.Viewport.Height;
			//Camera_c.s_view = Matrix.CreateLookAt( new Vector3(0,0,20.0f),
			//                                       Vector3.Zero,
			//                                       Vector3.Up);      
	    
			//Camera_c.s_projection = Matrix.CreatePerspectiveFieldOfView(MathHelper.ToRadians(45.0f), 
			//                                                            aspectRatio, 
			//                                                            1.0f, 
			//                                                            1000.0f);
                                                             
			m_timer = new Timer();
			m_timer.Interval = 10;
			m_timer.Tick += new EventHandler(Draw);
			m_timer.Start();
			
			m_model[0] = new Model_c();
			m_model[1] = new Model_c();
			
			m_model[0].m_shape			 = new ShapeSphere( 5.0f );
			m_model[0].m_hullMaker		 = new HullMaker(m_model[0].m_shape, -1);
			m_model[0].m_position		 = new Vector3(8,8,0);
			
			m_model[1].m_shape			 = new ShapeCube( new Vector3(5, 10, 15) );
			m_model[1].m_hullMaker		 = new HullMaker(m_model[1].m_shape, -1);
			m_model[1].m_position		 = new Vector3(-8,8,0);
		}
		
		void Draw(object sender, EventArgs e)
		{	        
	        UpdateCamera();
	        
			m_device.Clear(ClearOptions.Target | ClearOptions.DepthBuffer,
						   Microsoft.Xna.Framework.Graphics.Color.Blue,
						   1.0f, 0);
			
			
			
			Collision.DrawDebugInfo( m_device );
			
			for (int i=0; i<2; i++)
			{
				if (m_model[i].m_hullMaker!=null)
				{
					m_model[i].m_hullMaker.DebugDraw( m_device, m_model[i].m_rotation, m_model[i].m_position, m_model[i].m_colour );
				}
			}
			
			
			if (m_model[0].m_hullMaker!=null && m_model[1].m_hullMaker!=null)
			{
				if (Collision.HasCollision( m_model[0].m_shape, m_model[0].m_rotation, m_model[0].m_position,
											m_model[1].m_shape, m_model[1].m_rotation, m_model[1].m_position))
				{
					m_model[1].m_colour = Microsoft.Xna.Framework.Graphics.Color.Orange;
				}
				else 
				{
					m_model[1].m_colour = Microsoft.Xna.Framework.Graphics.Color.Green;
				}
				
			}
			
			/*
			if (m_hullMaker!=null)
			{
				m_hullMaker.DebugDraw( m_device );
				
				Vector3 hitPoint =
				m_shape.GetSupportPoint( m_supportNormal * 20 );
				
				m_random.X += 0.01f;
				m_random.Y -= 0.02f;
				m_random.Z += 0.05f;
				m_supportNormal.X = (float)Math.Sin(m_random.X);
				m_supportNormal.Y = (float)Math.Sin(m_random.Y);
				m_supportNormal.Z = (float)Math.Sin(m_random.Z);
				if (m_supportNormal.LengthSquared()<0.01f)
				{
					m_supportNormal = Vector3.Up;
				}
				m_supportNormal.Normalize();
				
				DrawLine_c.DrawLine( m_device, Vector3.Zero, m_supportNormal*20.0f, Microsoft.Xna.Framework.Graphics.Color.Yellow);
				
				DrawLine_c.DrawCross( m_device, hitPoint, 5.0f );
				
			}
			*/
			
			if (GetAsyncKeyState((int)System.Windows.Forms.Keys.A) != 0)	m_model[1].m_position.X += 0.2f;
			if (GetAsyncKeyState((int)System.Windows.Forms.Keys.D) != 0)	m_model[1].m_position.X -= 0.2f;
			if (GetAsyncKeyState((int)System.Windows.Forms.Keys.W) != 0)	m_model[1].m_position.Y += 0.2f;
			if (GetAsyncKeyState((int)System.Windows.Forms.Keys.S) != 0)	m_model[1].m_position.Y -= 0.2f;

			
			
	        
			m_device.Present();
		}

		private void buttonEllipsoid_Click(object sender, EventArgs e)
		{
			m_model[1].m_shape			 = new ShapeEllipsoid( new Vector3(5, 10, 5) );
			m_model[1].m_hullMaker		 = new HullMaker(m_model[1].m_shape, -1);
		}

		private void buttonCube_Click(object sender, EventArgs e)
		{
			m_model[1].m_shape			 = new ShapeCube( new Vector3(5, 10, 15) );
			m_model[1].m_hullMaker		 = new HullMaker(m_model[1].m_shape, -1);
		}

		private void buttonFootball_Click(object sender, EventArgs e)
		{
			m_model[1].m_shape			 = new ShapeFootball( 5, 10 );
			m_model[1].m_hullMaker		 = new HullMaker(m_model[1].m_shape, -1);
		}

		private void buttonSphere_Click(object sender, EventArgs e)
		{
			m_model[1].m_shape			 = new ShapeSphere( 5 );
			m_model[1].m_hullMaker		 = new HullMaker(m_model[1].m_shape, -1);
		}

		private void buttonPoint_Click(object sender, EventArgs e)
		{
			m_model[1].m_shape			 = new ShapePoint( Vector3.Zero );
			m_model[1].m_hullMaker		 = new HullMaker(m_model[1].m_shape, -1);

		}

		private void buttonRectPlane_Click(object sender, EventArgs e)
		{
			m_model[1].m_shape			 = new ShapeRectanglePlane( 5, 10 );
			m_model[1].m_hullMaker		 = new HullMaker(m_model[1].m_shape, -1);

		}

		private void buttonLine_Click(object sender, EventArgs e)
		{
			m_model[1].m_shape			 = new ShapeSegment( 10 );
			m_model[1].m_hullMaker		 = new HullMaker(m_model[1].m_shape, -1);

		}

		private void buttonCircle_Click(object sender, EventArgs e)
		{
			m_model[1].m_shape			 = new ShapeCirclePlane( 10 );
			m_model[1].m_hullMaker		 = new HullMaker(m_model[1].m_shape, -1);
		}

		private void buttonCyclinder_Click(object sender, EventArgs e)
		{
			m_model[1].m_shape			 = new ShapeCyclinder(5, 5); //ShapeCirclePlane( 10 );
			m_model[1].m_hullMaker		 = new HullMaker(m_model[1].m_shape, -1);
		}
	}
}
